	list	p=12f629
	#include <p12f629.inc>
	errorlevel -302
	__CONFIG _CP_OFF & _CPD_OFF & _BODEN_OFF & _MCLRE_ON & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT 

ptime	equ	7		; timing const for P led

flag	equ	20h		; flag register
ledp	equ	0

djnz	equ	21h		; interference const
scratch	equ	22h		; interference counter
pcount	equ	23h		; countdown za P led
delayl	equ	24h		; led "lo" expansion rotor
delayh	equ	25h		; led "hi" expansion rotor
timoutl	equ	26h
timouth	equ	27h

	org     0

	clrf	flag
	clrf	pcount
	clrf	delayl
	clrf	delayh
	clrf	timoutl
	clrf	gpio
	
	movlw	.194		; ON time (until sleep) x 3,1 sec
	movwf	timouth

	movlw	7		; !!!
	movwf	cmcon		; !!!
	bsf     status,rp0	; select register bank 1 
;	clrf	ansel		; (ovo samo ako se koristi 12F675)
	movlw	b'00101000'	; gpio 0,1,2,4 outputs, gpio 3,5 inputs
	movwf	trisio
	bcf     status,rp0	; select register bank 0
	movlw	07h
	movwf	t1con

	clrw
	call	show
	movlw	01h
	call	show
	movlw	03h
	call	show
	movlw	07h
	call	show
	movlw	06h
	call	show
	movlw	04h
	call	show		; led "on" sequence
	clrf	gpio
farm
	movf	djnz,w		; 1t   to avoid interference, total avg 15t
	iorlw	0f8h		; 1t   extra timing range between -.8 and -1
	movwf	scratch		; 1t   here scratch varies from 0f8h to 0ffh
unstable
	incfsz	scratch,f	; 1-17t (avg .9)  advance extra timing count
	goto	unstable	; 2-32t (avg .17) loop waisting extra time

	movf	tmr1l,w		; tmr1 = hardware transition detector
	iorwf	tmr1h,w
	bz	noinip1		; if tmr1=0, don't affect led p status
	clrf	tmr1l		; reinitialize hardware transition detector
	clrf	tmr1h
	goto	inipcou
noinip1
	movf	delayl,w	; delayl = 2nd software transition detector
	andlw	0feh		; avoid bit 0
	xorlw	02h		; falling edge test
	bnz	noinip3
inipcou
	movlw	ptime
	movwf	pcount		; initialize pcount for led p timing
noinip3	
	bcf	delayh,0	; initialize input bit in delay hi rotor
	bcf	delayl,0	; initialize input bit in delay low rotor
	movlw	10h		; value 10h = bit 4 set
	xorwf	gpio,f		; changes state of gpio.4 (square wave...
				; generation for probe tip hi-impedance out)
	btfsc	gpio,5		; test probe input logic level...
	goto	inputhi		; ...and jump if case 2: input high
				; ...or continue if case 1: input low
	btfss	gpio,4		; test state of hi-impedance output and...
	bsf	delayl,0	; ...switch on led l because hi-ipm out was lo
	goto	continpx	; jump to skip case 2
inputhi				; entry point for case 2: input high
	btfsc	gpio,4		; test state of hi-impedance output and...
	bsf	delayh,0	; ...turn on led h because hi-imp out was high
continpx			; moves lhp leds from flag to gpio
	bcf	status,c
	rlf	delayl,f	; propagate bit thru delayl rotor
	bcf	status,c
	rlf	delayh,f	; propagate bit thru delayh rotor
				; transfer leds status from flag bits to gpio
	movf	gpio,w
	andlw	10h		; only bit 4 (hi-imp out) preserved

	movf	delayl,f	; test if delayl=0
	btfss	status,z
	iorlw	01h		; set led "L" if delayl>0

	movf	delayh,f	; test if delayh=0
	btfss	status,z
	iorlw	02h		; set led "H" if delayh>0

	btfsc	flag,ledp
	iorlw	04h		; set led "P" if ledp set
	
	movwf	gpio

	incfsz	djnz,f		; test if this was 256th pass...
	goto	farm		; ...otherwise loop

;------------------------------ passes here at each 256. step (about 15 ms)

	bcf	flag,ledp	; reset led p flag (will be set if pcount>0)
	movf	pcount,f	; test pcount status...
	bz	pcount0		; jump if pcount = 0

	decf	pcount,f	; if pcount>0, then decrement it
	movf	delayl,w	; w>0 if led l is on
	iorwf	delayh,w	; w>0 if led l or led h is on
	btfss	status,z	; ...skip if both l and h leds are off
	bsf	flag,ledp	; if pcount>0 then dec pcount, and set led p
pcount0
	decfsz	timoutl,f	; timeout lo counter...
	goto	farm		; ... not yet zero: loop

	decfsz	timouth,f	; timeout hi counter...
	goto	farm		; ... not yet zero: loop
				; *** exit 3: continue with timeout process
	clrw
	call	show
	movlw	04h
	call	show
	movlw	06h
	call	show
	movlw	07h
	call	show
	movlw	03h
	call	show
	movlw	01h
	call	show
	clrf	gpio
	bsf     status,rp0	; set file register bank to 1 
	movlw	b'00001000'
	movwf	trisio
	bcf     status,rp0	; set file register bank to 0
	sleep

show
	movwf	gpio
	movlw	.80
	movwf	djnz
loop
	decfsz  scratch,f	; 1t
	goto	loop		; 2t

	decfsz	djnz,f
	goto	loop	
	return

	end
	
